
Redmine - Defect #31807

trac to redmine migration: ERROR:  duplicate key value violates unique constraint

"custom_fields_projects_pkey"

2019-07-26 04:56 - Sivaprakash Ramasamy

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Custom fields Estimated time: 0.00 hour

Target version:    

Resolution: Invalid Affected version: 3.4.5

Description

Hi,

Im trying to migrate trac project to redmine. Few hurdles on migration, fixed one by one. Now stuck with another issue mentioned

below.

Trac    1.0.4

SQLite    3.8.2

Environment:

Redmine version                3.4.5.stable

Ruby version                   2.4.4-p296 (2018-03-28) [x86_64-linux]

Rails version                  4.2.8

Environment                    production

Database adapter               PostgreSQL

Trac directory []: /opt/trac.bak

Trac database adapter (sqlite3, mysql2, postgresql) [sqlite3]:

Trac database encoding [UTF-8]:

Target project identifier []: mytrac

This project already exists in your Redmine database.

Are you sure you want to append data to this project ? [Y/n] Y

Migrating components...

Migrating milestones...

Migrating custom fields.rake aborted!

ActiveRecord::RecordNotUnique: PG::UniqueViolation: ERROR:  duplicate key value violates unique constraint

"custom_fields_projects_pkey"

DETAIL:  Key (custom_field_id, project_id)=(21, 261) already exists.

: INSERT INTO "custom_fields_projects" ("custom_field_id", "project_id") VALUES ($1, $2)

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql_adapter.rb:602:in `exec_prepared'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql_adapter.rb:602:in `block in exec_cache'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract_adapter.rb:484:in `block in log'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/notifications/instrumenter.rb:20:in `instrument'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract_adapter.rb:478:in `log'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql_adapter.rb:601:in `exec_cache'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql_adapter.rb:585:in `execute_and_clear'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql/database_statements.rb:160:in

`exec_query'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql/database_statements.rb:192:in

`exec_insert'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb:108:in `insert'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/query_cache.rb:14:in `insert'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/relation.rb:64:in `insert'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/persistence.rb:524:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/counter_cache.rb:139:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/locking/optimistic.rb:75:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/attribute_methods/dirty.rb:133:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/callbacks.rb:306:in `block in create_record'
/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:88:in `_run_callbacks__'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:778:in `_run_create_callbacks'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/callbacks.rb:306:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/timestamp.rb:57:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/persistence.rb:504:in `create_or_update'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/callbacks.rb:302:in `block in create_or_update'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:117:in `call'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:555:in `block (2 levels) in compile'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:505:in `call'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:92:in `__run_callbacks__'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:778:in `_run_save_callbacks'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/callbacks.rb:302:in `create_or_update'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/persistence.rb:142:in `save!'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/validations.rb:43:in `save!'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/attribute_methods/dirty.rb:29:in `save!'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:291:in `block in save!'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:351:in `block in with_transaction_returning_status'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb:211:in

`transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:220:in `transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:348:in `with_transaction_returning_status'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:291:in `save!'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/has_many_through_association.rb:117:in

`save_through_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/has_many_through_association.rb:66:in `insert_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:570:in `block (2 levels) in

concat_records'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:415:in `replace_on_target'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:410:in `add_to_target'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:569:in `block in concat_records'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:567:in `each'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:567:in `concat_records'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/has_many_association.rb:180:in `concat_records'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/has_many_through_association.rb:44:in `concat_records'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:175:in `block in concat'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:190:in `block in transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb:213:in `block in

transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/transaction.rb:184:in

`within_new_transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb:213:in

`transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:220:in `transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:189:in `transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:175:in `concat'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/has_many_through_association.rb:38:in `concat'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_proxy.rb:970:in `<<'

/usr/src/redmine/lib/tasks/migrate_from_trac.rake:451:in `block in migrate'

/usr/src/redmine/lib/tasks/migrate_from_trac.rake:437:in `each'

/usr/src/redmine/lib/tasks/migrate_from_trac.rake:437:in `migrate'

/usr/src/redmine/lib/tasks/migrate_from_trac.rake:772:in `block (2 levels) in <top (required)>'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:273:in `block in execute'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:273:in `each'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:273:in `execute'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:214:in `block in invoke_with_call_chain'

/usr/local/lib/ruby/2.4.0/monitor.rb:214:in `mon_synchronize'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:194:in `invoke_with_call_chain'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:183:in `invoke'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:160:in `invoke_task'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:116:in `block (2 levels) in top_level'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:116:in `each'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:116:in `block in top_level'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:125:in `run_with_threads'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:110:in `top_level'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:83:in `block in run'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:186:in `standard_exception_handling'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:80:in `run'

2025-04-28 2/4



/usr/local/bundle/gems/rake-12.3.3/exe/rake:27:in `<top (required)>'

/usr/local/bundle/bin/rake:23:in `load'

/usr/local/bundle/bin/rake:23:in `<main>'

Caused by:

PG::UniqueViolation: ERROR:  duplicate key value violates unique constraint "custom_fields_projects_pkey"

DETAIL:  Key (custom_field_id, project_id)=(21, 261) already exists.

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql_adapter.rb:602:in `exec_prepared'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql_adapter.rb:602:in `block in exec_cache'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract_adapter.rb:484:in `block in log'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/notifications/instrumenter.rb:20:in `instrument'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract_adapter.rb:478:in `log'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql_adapter.rb:601:in `exec_cache'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql_adapter.rb:585:in `execute_and_clear'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql/database_statements.rb:160:in

`exec_query'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/postgresql/database_statements.rb:192:in

`exec_insert'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb:108:in `insert'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/query_cache.rb:14:in `insert'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/relation.rb:64:in `insert'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/persistence.rb:524:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/counter_cache.rb:139:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/locking/optimistic.rb:75:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/attribute_methods/dirty.rb:133:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/callbacks.rb:306:in `block in create_record'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:88:in `_run_callbacks__'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:778:in `_run_create_callbacks'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/callbacks.rb:306:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/timestamp.rb:57:in `_create_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/persistence.rb:504:in `create_or_update'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/callbacks.rb:302:in `block in create_or_update'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:117:in `call'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:555:in `block (2 levels) in compile'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:505:in `call'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:92:in `__run_callbacks__'

/usr/local/bundle/gems/activesupport-4.2.8/lib/active_support/callbacks.rb:778:in `_run_save_callbacks'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/callbacks.rb:302:in `create_or_update'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/persistence.rb:142:in `save!'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/validations.rb:43:in `save!'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/attribute_methods/dirty.rb:29:in `save!'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:291:in `block in save!'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:351:in `block in with_transaction_returning_status'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb:211:in

`transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:220:in `transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:348:in `with_transaction_returning_status'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:291:in `save!'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/has_many_through_association.rb:117:in

`save_through_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/has_many_through_association.rb:66:in `insert_record'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:570:in `block (2 levels) in

concat_records'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:415:in `replace_on_target'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:410:in `add_to_target'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:569:in `block in concat_records'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:567:in `each'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:567:in `concat_records'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/has_many_association.rb:180:in `concat_records'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/has_many_through_association.rb:44:in `concat_records'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:175:in `block in concat'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:190:in `block in transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb:213:in `block in

transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/transaction.rb:184:in

`within_new_transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb:213:in
`transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/transactions.rb:220:in `transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:189:in `transaction'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_association.rb:175:in `concat'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/has_many_through_association.rb:38:in `concat'

/usr/local/bundle/gems/activerecord-4.2.8/lib/active_record/associations/collection_proxy.rb:970:in `<<'

/usr/src/redmine/lib/tasks/migrate_from_trac.rake:451:in `block in migrate'

/usr/src/redmine/lib/tasks/migrate_from_trac.rake:437:in `each'

/usr/src/redmine/lib/tasks/migrate_from_trac.rake:437:in `migrate'

/usr/src/redmine/lib/tasks/migrate_from_trac.rake:772:in `block (2 levels) in <top (required)>'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:273:in `block in execute'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:273:in `each'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:273:in `execute'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:214:in `block in invoke_with_call_chain'

/usr/local/lib/ruby/2.4.0/monitor.rb:214:in `mon_synchronize'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:194:in `invoke_with_call_chain'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/task.rb:183:in `invoke'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:160:in `invoke_task'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:116:in `block (2 levels) in top_level'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:116:in `each'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:116:in `block in top_level'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:125:in `run_with_threads'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:110:in `top_level'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:83:in `block in run'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:186:in `standard_exception_handling'

/usr/local/bundle/gems/rake-12.3.3/lib/rake/application.rb:80:in `run'

/usr/local/bundle/gems/rake-12.3.3/exe/rake:27:in `<top (required)>'

/usr/local/bundle/bin/rake:23:in `load'

/usr/local/bundle/bin/rake:23:in `<main>'

Tasks: TOP => redmine:migrate_from_trac

History

#1 - 2019-08-07 11:58 - Sivaprakash Ramasamy

- Status changed from New to Resolved

Deleted the redmine project and recreated

#2 - 2019-08-07 12:43 - Marius BĂLTEANU

- Status changed from Resolved to Closed

- Resolution set to Invalid
